#include<iostream>
#include<cmath>
using namespace std;

class point
{public: int x; int y;};
class dpoint
{public: double x; double y;};

double dist(point a, dpoint c)
{return sqrt((a.x-c.x)*(a.x-c.x)+(a.y-c.y)*(a.y-c.y));}
double dist(dpoint a, dpoint c)
{return sqrt((a.x-c.x)*(a.x-c.x)+(a.y-c.y)*(a.y-c.y));}

int sec(point p1, point p2, point a, point b, dpoint& c)
{
  int u1=(a.x-p1.x)*(b.y-a.y)-(a.y-p1.y)*(b.x-a.x);
  int u2=(p2.x-p1.x)*(b.y-a.y)-(p2.y-p1.y)*(b.x-a.x);
  if(u2==0) // line (a,b) is parallel or coincide with segment (p1,p2)
  {
    if(u1==0) return 1; // coincide
    else return 2; // parallel
  }
  if(u1==0) {c.x=p1.x; c.y=p1.y; return -1;} // line (a,b) goes via p1
  if(u1==u2) {c.x=p2.x; c.y=p2.y; return -2;} // line (a,b) goes via p2
  double u=(double) u1/u2;
  c.x=p1.x+(p2.x-p1.x)*u;
  c.y=p1.y+(p2.y-p1.y)*u;    
  // if((u<0.0)||(u>1.0)) return 3; 
  // line (a,b) intersects line (p1,p2), but outside segment:
  if((u1<0)&&(u2>0)) return 3;
  if((u1>0)&&(u2<0)) return 3;
  if((u1>u2)&&(u2>0)) return 3;
  if((u1<u2)&&(u2<0)) return 3;
  return 0;    
}

point p1,p2,p3,a,b;
void input()
{
 cin >> p1.x >> p1.y;
 cin >> p2.x >> p2.y;
 cin >> p3.x >> p3.y;
 cin >> a.x >> a.y;
 cin >> b.x >> b.y;
}

dpoint c1,c2,c3;
double compute()
{
 int k1 = sec(p1,p2,a,b,c1);
 int k2 = sec(p2,p3,a,b,c2);
 int k3 = sec(p3,p1,a,b,c3);
 
 if(k1==-1)if(k2==0)return dist(p1,c2);
 if(k2==-1)if(k3==0)return dist(p2,c3);
 if(k3==-1)if(k1==0)return dist(p3,c1);
 if(k1==0)if(k2==0)return dist(c1,c2);
 if(k1==0)if(k3==0)return dist(c1,c3);
 if(k2==0)if(k3==0)return dist(c2,c3);
 return 0.0;
}

int main()
{
 input();
 double d=compute();
 cout.precision(10);
 cout << d << endl;
}

